/*  -*- Mode: Asm -*-  */
/*
    floatsisf.S is part of     FPlib V 0.3.0       ported to avr-as
    for copyright and details see readme.fplib

 *------------------------------------------------------------------------------------------
 * data conversion section
 *------------------------------------------------------------------------------------------
 * A = (float)(unsigned long)A
 */

#include "gasava.inc"
#include "fplib.inc"

          TEXT_SEG(fplib, __floatsisf)
          FUNCTION(__floatunssisf)

GLOBAL(__floatunssisf)           ; - convert signed long to float
           CLT                   ; fp_merge expects T:sign
           RJMP    ___floatsisf_10

/*-------------------------------------------------------------------------------------------
 * A = (float)(signed long)A
 */

GLOBAL(__floatsisf)              ; - convert signed long to float
           BST     rA3,7         ; fp_merge expects T:sign
           BRTC    ___floatsisf_10
           RCALL   _U(__fp_lneg)
 ___floatsisf_10:
           MOV     rAE,rA0       ; rA2::rA0:rAE mantissa
           MOV     rA0,rA1
           MOV     rA1,rA2
           MOV     rA2,rA3       ; rA3:exponent
           LDI     rA3,0x7F+31   ; 1L = 00 00 00 01   =>
                                 ; 0:7F+31:00 00 00 01 =>
                                 ; 0:7F:80 00 00       => 3F 80 00 00
           CLR     rT0           ; clear extended rounding precision
           RJMP    _U(__fp_merge)

          ENDFUNC

