/*  -*- Mode: Asm -*-  */
/*
    pow.S is part of     FPlib V 0.3.0       ported to avr-as
    for copyright and details see readme.fplib

 *----------------------------------------------------------------------------------------
 *
 *
 *	A = pow(x,y) = exp( log(x)*y )  | x > 0
 */

#include "gasava.inc"
#include "fplib.inc"

          TEXT_SEG(fplib, pow)
          FUNCTION(pow)

GLOBAL(pow)
   TST   rB3
   BREQ  _pow_100		; x ^ 0 = 1.0
   TST   rA3
   BRMI  _pow_10
   BREQ  _pow_100
 _pow_00:
   PUSH  rB3
   PUSH  rB2
   PUSH  rB1
   PUSH  rB0
   RCALL _U(log)
   POP   rB0
   POP   rB1
   POP   rB2
   POP   rB3
   RCALL _U(__mulsf3)
   RJMP  _U(exp)

 _pow_10:
	/* x < 0 -> no rational power allowed
	 *          check if B is an integer number
	 * if yes then pow(x,y) =
         */
   PUSH  rA3
   PUSH  rA2
   PUSH  rA1
   PUSH  rA0
   PUSH  rB3
   PUSH  rB2
   PUSH  rB1
   PUSH  rB0
   MOV   rA3,rB3
   MOV   rA2,rB2
   MOV   rA1,rB1
   MOV   rA0,rB0
   RCALL _U(__fixsfsi)

   RCALL _U(__subsf3)
   CP    rA3,rT1c
   CPC   rA2,rT1c
   CPC   rA1,rT1c
   CPC   rA0,rT1c
   POP   rB0
   POP   rB1
   POP   rB2
   POP   rB3
   POP   rA0
   POP   rA1
   POP   rA2
   POP   rA3
   BREQ  _pow_20
   ANDI  rA3,0x7F
   SUBI  rB3,0x80
   RCALL _pow_10
   SUBI  rB3,0x80

 _pow_20:
   RJMP  _U(__fp_nanEDOM)

 _pow_100:
   LDI   rA3,0x3F
   LDI   rA2,0x80
 _pow_101:
   CLR   rA1
   CLR   rA2
   RET

          ENDFUNC


