/*  -*- Mode: Asm -*-  */
/*
    sinh.S is part of     FPlib V 0.3.0       ported to avr-as
    for copyright and details see readme.fplib

 *----------------------------------------------------------------------------------------
 *
 *
 *	A = sinh(A) = 1/2 ( exp(A) - exp(-A) )
 */

#include "gasava.inc"
#include "fplib.inc"

          TEXT_SEG(fplib, sinh)
          FUNCTION(sinh)

GLOBAL(sinh)
   RCALL _U(exp)
   PUSH  rA0
   PUSH  rA1
   PUSH  rA2
   PUSH  rA3
   RCALL _U(inverse)
   ORI   rA3,0x80		; exp(-x) = -exp(-x)
   POP   rB3
   POP   rB2
   POP   rB1
   POP   rB0
   RCALL _U(__addsf3)		; -exp(-x) + exp(x)
			; check for NaN
   LDI   rB2,0xFF		;
   LDI   rB3,0xFF		; decrement exponent by 1 = * 0.5
   RJMP  _U(ldexp)

          ENDFUNC


